Bug 157900 - [not quite PATCH] tg3 driver crashes kernel with BCM5752 chip, newer driver is OK
[not quite PATCH] tg3 driver crashes kernel with BCM5752 chip, newer driver i...
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 4
Classification: Red Hat
Component: kernel (Show other bugs)
4.0
All Linux
medium Severity medium
: ---
: ---
Assigned To: John W. Linville
Brian Brock
http://www-personal.engin.umich.edu/~...
:
Depends On:
Blocks: 156323 157340
  Show dependency treegraph
 
Reported: 2005-05-16 17:00 EDT by wingc
Modified: 2007-11-30 17:07 EST (History)
1 user (show)

See Also:
Fixed In Version: RHSA-2005-514
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2005-10-05 09:07:33 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
backport of 2.6.12-rc4 tg3 driver to RHEL4 2.6.9-6.37.EL beta kernel (173.30 KB, application/octet-stream)
2005-05-16 17:00 EDT, wingc
no flags Details

  None (edit)
Description wingc 2005-05-16 17:00:08 EDT
Description of problem:

The tg3 driver in the most recent RHEL4 beta (2.6.9-6.37.ELsmp) tries to support
the BCM5752 chip, but doesn't work properly on my hardware (HP xw4300
workstation, x86_64, BCM5752 PCI-Express, with MSI support). It detects the 5752
chip but crashes the kernel when you actually try to use the network interface.

I backported the tg3 driver from the most recent Linux kernel (2.6.12-rc4) and
it works properly.

You should update the tg3 driver in RHEL4 to the most recent version (3.27), or
else remove the PCI ID for the 5752 chip (14e4:1600) from your tg3 driver since
it doesn't work.

I attached my backport of the 2.6.12-rc4 tg3 driver. I built it as an external
module. Sorry, I didn't create a patch against your kernel sources.



Version-Release number of selected component (if applicable):

RHEL4 beta kernel, 2.6.9-6.37.EL

How reproducible:

Always

Steps to Reproduce:
1. load the tg3 driver from the RHEL4 kernel
2. try to bring up the interface
  
Actual results:

the machine will lock up and display a stack trace, then hang completely

Expected results:

The tg3 driver from 2.6.12-rc4, which is labeled: 'v3.27 (May 5, 2005)', works
properly.

Additional info:

My backport of the 2.6.12-rc4 driver is available at:

http://www-personal.engin.umich.edu/~wingc/code/tg3-rhel4/tg3-linux-2.6.12-rc4.tar.gz


I also included it as an attachment to this bugzilla. I'll leave it up to you to
decide how you want to integrate it into the RHEL4 kernel. I left tg3.c as-is
for the most part, and put other stuff in compatability headers and files. I
only reverted one patch to tg3.c (which changed pci_save_state() in an
incompatible way between Red Hat's 2.6.9 and 2.6.12, that I couldn't work around
in a header file)
Comment 1 wingc 2005-05-16 17:00:08 EDT
Created attachment 114448 [details]
backport of 2.6.12-rc4 tg3 driver to RHEL4 2.6.9-6.37.EL beta kernel
Comment 2 John W. Linville 2005-05-18 11:20:56 EDT
We are aware of this issue...suffice it to say that there is a long story 
here... :-) 
 
Unfortunately, this won't make U1...I believe HP intends to provide a driver 
disk for U1 installation.  This should be working in U2. 
 
Thanks for the patch!  That's the kind of bug report I like... :-) 
Comment 3 John W. Linville 2005-05-18 15:46:10 EDT
BTW, you may want to try the kernels here: 
 
   http://people.redhat.com/linville/kernels/rhel4/ 
 
These include the later tg3 driver (probably the same one you found) and 
should work fine w/ your xw4300... 
Comment 4 wingc 2005-05-18 16:08:54 EDT
Thanks, but I probably won't try out those test kernels until they include the
patch from bug #157902 as well. Otherwise, although tg3 should be fixed, the
SATA controller won't work :)
Comment 5 John W. Linville 2005-05-18 16:21:39 EDT
Well, then you are in luck...take a look at jwltest-ahci-bar-hack.patch, which 
is part of those kernels... :-) 
Comment 6 wingc 2005-05-18 16:31:23 EDT
Just tested kernel-smp-2.6.9-6.46.EL.jwltest.27.x86_64.rpm and confirmed that
both SATA and tg3 are working.

Thanks.
Comment 8 Marty Wesley 2005-05-26 02:54:03 EDT
PM ACK for U2.
Comment 17 Red Hat Bugzilla 2005-10-05 09:07:33 EDT
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on the solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2005-514.html

Note You need to log in before you can comment on or make changes to this bug.